QCPSelectionRect Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Signals | Protected Functions
QCPSelectionRect Class Reference

Provides rect/rubber-band data selection and range zoom interaction. More...

Inheritance diagram for QCPSelectionRect:

## Public Functions
| QCPSelectionRect (QCustomPlot *parentPlot)
QRect | rect () const
QCPRange | range (const QCPAxis *axis) const
QPen | pen () const
QBrush | brush () const
bool | isActive () const
void | setPen (const QPen &pen)
void | setBrush (const QBrush &brush)
Q_SLOT void | cancel ()
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
bool | realVisibility () const

## Signals
void | started (QMouseEvent *event)
void | changed (const QRect &rect, QMouseEvent *event)
void | canceled (const QRect &rect, QInputEvent *event)
void | accepted (const QRect &rect, QMouseEvent *event)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Protected Functions
virtual void | startSelection (QMouseEvent *event)
virtual void | moveSelection (QMouseEvent *event)
virtual void | endSelection (QMouseEvent *event)
virtual void | keyPressEvent (QKeyEvent *event)
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | draw (QCPPainter *painter)
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Detailed Description

Provides rect/rubber-band data selection and range zoom interaction.

QCPSelectionRect is used by QCustomPlot when the QCustomPlot::setSelectionRectMode is not QCP::srmNone. When the user drags the mouse across the plot, the current selection rect instance (QCustomPlot::setSelectionRect) is forwarded these events and makes sure an according rect shape is drawn. At the begin, during, and after completion of the interaction, it emits the corresponding signals started, changed, canceled, and accepted.

The QCustomPlot instance connects own slots to the current selection rect instance, in order to react to an accepted selection rect interaction accordingly.

isActive can be used to check whether the selection rect is currently active. An ongoing selection interaction can be cancelled programmatically via calling cancel at any time.

The appearance of the selection rect can be controlled via setPen and setBrush.

If you wish to provide custom behaviour, e.g. a different visual representation of the selection rect (QCPSelectionRect::draw), you can subclass QCPSelectionRect and pass an instance of your subclass to QCustomPlot::setSelectionRect.

## Constructor & Destructor Documentation

## ◆ QCPSelectionRect()

QCPSelectionRect::QCPSelectionRect | ( | QCustomPlot * | parentPlot | ) |
| explicit

Creates a new QCPSelectionRect instance. To make QCustomPlot use the selection rect instance, pass it to QCustomPlot::setSelectionRect. parentPlot should be set to the same QCustomPlot widget.

## Member Function Documentation

## ◆ range()

QCPRange QCPSelectionRect::range | ( | const QCPAxis * | axis | ) | const

A convenience function which returns the coordinate range of the provided axis, that this selection rect currently encompasses.

## ◆ isActive()

bool QCPSelectionRect::isActive | ( |  | ) | const
| inline

Returns true if there is currently a selection going on, i.e. the user has started dragging a selection rect, but hasn't released the mouse button yet.

See also
  cancel

## ◆ setPen()

void QCPSelectionRect::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the selection rect outline.

See also
  setBrush

## ◆ setBrush()

void QCPSelectionRect::setBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used to fill the selection rect. By default the selection rect is not filled, i.e. brush is Qt::NoBrush.

See also
  setPen

## ◆ cancel()

void QCPSelectionRect::cancel | ( |  | ) |

If there is currently a selection interaction going on (isActive), the interaction is canceled. The selection rect will emit the canceled signal.

## ◆ started

void QCPSelectionRect::started | ( | QMouseEvent * | event | ) |
| signal

This signal is emitted when a selection rect interaction was initiated, i.e. the user just started dragging the selection rect with the mouse.

## ◆ changed

void QCPSelectionRect::changed | ( | const QRect & | rect,
|  | QMouseEvent * | event )
| signal

This signal is emitted while the selection rect interaction is ongoing and the rect has changed its size due to the user moving the mouse.

Note that rect may have a negative width or height, if the selection is being dragged to the upper or left side of the selection rect origin.

## ◆ canceled

void QCPSelectionRect::canceled | ( | const QRect & | rect,
|  | QInputEvent * | event )
| signal

This signal is emitted when the selection interaction was cancelled. Note that event is `nullptr` if the selection interaction was cancelled programmatically, by a call to cancel.

The user may cancel the selection interaction by pressing the escape key. In this case, event holds the respective input event.

Note that rect may have a negative width or height, if the selection is being dragged to the upper or left side of the selection rect origin.

## ◆ accepted

void QCPSelectionRect::accepted | ( | const QRect & | rect,
|  | QMouseEvent * | event )
| signal

This signal is emitted when the selection interaction was completed by the user releasing the mouse button.

Note that rect may have a negative width or height, if the selection is being dragged to the upper or left side of the selection rect origin.

## ◆ startSelection()

void QCPSelectionRect::startSelection | ( | QMouseEvent * | event | ) |
| protectedvirtual

This method is called by QCustomPlot to indicate that a selection rect interaction was initiated. The default implementation sets the selection rect to active, initializes the selection rect geometry and emits the started signal.

## ◆ moveSelection()

void QCPSelectionRect::moveSelection | ( | QMouseEvent * | event | ) |
| protectedvirtual

This method is called by QCustomPlot to indicate that an ongoing selection rect interaction needs to update its geometry. The default implementation updates the rect and emits the changed signal.

## ◆ endSelection()

void QCPSelectionRect::endSelection | ( | QMouseEvent * | event | ) |
| protectedvirtual

This method is called by QCustomPlot to indicate that an ongoing selection rect interaction has finished by the user releasing the mouse button. The default implementation deactivates the selection rect and emits the accepted signal.

## ◆ keyPressEvent()

void QCPSelectionRect::keyPressEvent | ( | QKeyEvent * | event | ) |
| protectedvirtual

This method is called by QCustomPlot when a key has been pressed by the user while the selection rect interaction is active. The default implementation allows to cancel the interaction by hitting the escape key.

## ◆ applyDefaultAntialiasingHint()

void QCPSelectionRect::applyDefaultAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedvirtual

This function applies the default antialiasing setting to the specified painter, using the function applyAntialiasingHint. It is the antialiasing state the painter is put in, when draw is called on the layerable. If the layerable has multiple entities whose antialiasing setting may be specified individually, this function should set the antialiasing state of the most prominent entity. In this case however, the draw function usually calls the specialized versions of this function before drawing each entity, effectively overriding the setting of the default antialiasing hint.

First example: QCPGraph has multiple entities that have an antialiasing setting: The graph line, fills and scatters. Those can be configured via QCPGraph::setAntialiased, QCPGraph::setAntialiasedFill and QCPGraph::setAntialiasedScatters. Consequently, there isn't only the QCPGraph::applyDefaultAntialiasingHint function (which corresponds to the graph line's antialiasing), but specialized ones like QCPGraph::applyFillAntialiasingHint and QCPGraph::applyScattersAntialiasingHint. So before drawing one of those entities, QCPGraph::draw calls the respective specialized applyAntialiasingHint function.

Second example: QCPItemLine consists only of a line so there is only one antialiasing setting which can be controlled with QCPItemLine::setAntialiased. (This function is inherited by all layerables. The specialized functions, as seen on QCPGraph, must be added explicitly to the respective layerable subclass.) Consequently it only has the normal QCPItemLine::applyDefaultAntialiasingHint. The QCPItemLine::draw function doesn't need to care about setting any antialiasing states, because the default antialiasing hint is already set on the painter when the draw function is called, and that's the state it wants to draw the line with.

Implements QCPLayerable.

## ◆ draw()

void QCPSelectionRect::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

If the selection rect is active (isActive), draws the selection rect defined by mRect.

For general information about this virtual method, see the base class implementation.

Implements QCPLayerable.

The documentation for this class was generated from the following files:

- src/selectionrect.h
- src/selectionrect.cpp